Package: mixedBayes
Type: Package
Title: Bayesian Longitudinal Regularized Quantile Mixed Model
Version: 0.2.5
Date: 2026-04-23
Authors@R: c( person("Kun", "Fan", role = c("aut", "cre") , email = "fzt0428@gmail.com"),
              person("Shejuty", "Devnath", role = "aut"),
              person("Cen", "Wu", role = "aut"))
Description: With high-dimensional omics features, repeated measure ANOVA leads to longitudinal gene-environment interaction studies that have intra-cluster correlations, outlying observations and structured sparsity arising from the ANOVA design. In this package, we have developed robust sparse Bayesian mixed effect models tailored for the above studies (Fan et al. (2025) <doi:10.1093/jrsssc/qlaf027>). An efficient Gibbs sampler has been developed to facilitate fast computation. The Markov chain Monte Carlo algorithms of the proposed and alternative methods are efficiently implemented in 'C++'. The development of this software package and the associated statistical methods have been partially supported by an Innovative Research Award from Johnson Cancer Research Center, Kansas State University.
Depends: R (>= 4.2.0)
License: GPL-2
Encoding: UTF-8
URL: https://github.com/kunfa/mixedBayes
BugReports: https://github.com/kunfa/mixedBayes/issues
Imports: Rcpp
LinkingTo: Rcpp, RcppArmadillo
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2026-04-23 06:13:25 UTC; kunfan
Author: Kun Fan [aut, cre],
  Shejuty Devnath [aut],
  Cen Wu [aut]
Maintainer: Kun Fan <fzt0428@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-23 06:30:02 UTC
Built: R 4.5.2; x86_64-apple-darwin20; 2026-04-23 06:47:50 UTC; unix
Archs: mixedBayes.so.dSYM

Package: mixedBayes
Type: Package
Title: Bayesian Longitudinal Regularized Quantile Mixed Model
Version: 0.2.5
Date: 2026-04-23
Authors@R: c( person("Kun", "Fan", role = c("aut", "cre") , email = "fzt0428@gmail.com"),
              person("Shejuty", "Devnath", role = "aut"),
              person("Cen", "Wu", role = "aut"))
Description: With high-dimensional omics features, repeated measure ANOVA leads to longitudinal gene-environment interaction studies that have intra-cluster correlations, outlying observations and structured sparsity arising from the ANOVA design. In this package, we have developed robust sparse Bayesian mixed effect models tailored for the above studies (Fan et al. (2025) <doi:10.1093/jrsssc/qlaf027>). An efficient Gibbs sampler has been developed to facilitate fast computation. The Markov chain Monte Carlo algorithms of the proposed and alternative methods are efficiently implemented in 'C++'. The development of this software package and the associated statistical methods have been partially supported by an Innovative Research Award from Johnson Cancer Research Center, Kansas State University.
Depends: R (>= 4.2.0)
License: GPL-2
Encoding: UTF-8
URL: https://github.com/kunfa/mixedBayes
BugReports: https://github.com/kunfa/mixedBayes/issues
Imports: Rcpp
LinkingTo: Rcpp, RcppArmadillo
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2026-04-23 06:13:25 UTC; kunfan
Author: Kun Fan [aut, cre],
  Shejuty Devnath [aut],
  Cen Wu [aut]
Maintainer: Kun Fan <fzt0428@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-23 06:30:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 20:27:11 UTC; unix
Archs: mixedBayes.so.dSYM

<!-- README.md is generated from README.Rmd. Please edit that file -->

# mixedBayes

> Bayesian Longitudinal Regularized Quantile Mixed Model
<!-- badges: start -->

[![CRAN](https://www.r-pkg.org/badges/version/mixedBayes)](https://cran.r-project.org/package=mixedBayes)
[![CRAN RStudio mirror
downloads](https://cranlogs.r-pkg.org/badges/grand-total/mixedBayes)](https://www.r-pkg.org:443/pkg/mixedBayes)
[![CRAN RStudio mirror
downloads](https://cranlogs.r-pkg.org/badges/last-month/mixedBayes)](https://www.r-pkg.org:443/pkg/mixedBayes)

<!-- badges: end -->

With high-dimensional omics features, repeated measure ANOVA leads to longitudinal gene-environment interaction studies that have intra-cluster correlations, outlying observations and structured sparsity arising from the ANOVA design. In this package, we have developed robust sparse Bayesian mixed effect models tailored for the above studies ([Fan et al. (2025)](https://doi.org/10.1093/jrsssc/qlaf027)). An efficient Gibbs sampler has been developed to facilitate fast computation. The Markov chain Monte Carlo algorithms of the proposed and alternative methods are efficiently implemented in 'C++'. The development of this software package and the associated statistical methods have been partially supported by an Innovative Research Award from Johnson Cancer Research Center, Kansas State University.

## How to install

  - To install from github, run these two lines of code in R

<!-- end list -->

    install.packages("devtools")
    devtools::install_github("kunfa/mixedBayes")

  - Released versions of mixedBayes are available on CRAN
    [(link)](https://cran.r-project.org/package=mixedBayes), and can be
    installed within R via

<!-- end list -->

    install.packages("mixedBayes")
    
## Load the package

    library(mixedBayes)
    
## Data generation under random intercept-and-slope model with t(2) error

    Data <- function (n,p,k,q,quant){
    sigma2=1
    # Generate genetic factors
    sig = matrix(0,p,p)
    for (i in 1:p)
    {
    for(j in 1:p)
    {
      sig[i,j] = 0.5^abs(i-j)
    }
    }
  
    g = mvrnorm(n,rep(0,p),sig)
    g = as.matrix(g)
    g = scale(g)
  
    # True main effects for genetic variables 
    beta_true = rep(0,p)
    beta_true[c(2,4,7,12)] = runif(4,0.4,0.8)
  
    # Generate environmental factors (a group of 3 dummy variables)
    group <- sample(0:3, size = n, replace = TRUE)
  
    e1 <- as.numeric(group == 1)
    e2 <- as.numeric(group == 2)
    e3 <- as.numeric(group == 3)
  
    e <- cbind(e1, e2, e3)
    e <- scale(e)
  
    # Fixed effects for environmental main effects
    alpha1= runif(q,0.4,0.8)
  
    # Fixed effects for time (polynomial terms)
    alpha2= runif(3,0.4,0.8)
  
    # Interaction terms
    w = c()
  
    for (i in 1:ncol(g))
    {
    
    w = cbind(w,g[,i]*e)
    
    }
  
    # True interaction effects
    eta_true <- rep(0, p * q)
    nz_block <- list(4:6, 10:12, 16:18, 19:21, 34:36, 43:45)
    for (idx in nz_block) {
     eta_true[idx] <- runif(q, 0.4, 0.8)
    }
  
    # Combine all coefficients
    betas_true <- c(beta_true, eta_true)
  
    #  Random effects design 
    k_1 <- 1:k
    k_1 <- k_1 - mean(k_1)
    z <- cbind(1, k_1)
  
    # fixed-effect design for time
    xi <- cbind(1, 1:k, (1:k)^2)
    X <- do.call(rbind, replicate(n, xi, simplify = FALSE))
  
    # Generate response 
    y <- matrix(0, n, k)
    for (i in 1:n) {
    ata <- runif(2,0,1)
    ei <- matrix(rep(e[i, ], each = k), nrow = k)
    gi <- matrix(rep(g[i, ], each = k), nrow = k)
    wi <- matrix(rep(w[i, ], each = k), nrow = k)
    error <- rt(k, 2)
    error <- error -quantile(error, probs = quant)
    y[i, ] <- ei %*% alpha1 +xi %*% alpha2 +gi %*% beta_true +wi %*% eta_true +z %*% ata + error
    }
  
    # Convert to long format
    y = reformat(k,y,type="r");g = reformat(k,g,type="d");e = reformat(k,e,type="d")
    dat <- list(y = y, g = g, e  = e, X  = X, coef = betas_true)
    return (dat)
    }
    
    library(MASS)
    library(mixedBayes)
    n=200;p=100;q=3;k=5;quant=0.5
    data = Data(n,p,k,q,quant)
    y = data$y
    e = data$e
    g = data$g
    X = data$X
    
#### Example.1 (proposed method: robust sparse bi-level selection under random intercept -and- slope model)
    
    fit = mixedBayes(y,e,X,g,k,structure="bilevel")
    
    # Estimated coefficients(posterior median)
    fit$coefficient
    
    # Identification
    beta_est = selection(fit,sparse=TRUE)
    coeff = data$coef
    index = which(coeff!=0) # true active predictors
    pos = which(beta_est != 0) # selected active predictors
    tp = length(intersect(index, pos))
    fp = length(pos) - tp
    
    # Prediction
    prediction=predict_mixedBayes(fit,y,X,e,g,k,slope=TRUE,loss = "L1")
    prediction
    
#### Example.2 (alternative: robust sparse individual level selection under random intercept -and- slope model)

    fit = mixedBayes(y,e,X,g,k,structure="individual")
    
    # Estimated coefficients(posterior median)
    fit$coefficient
    
    # Identification
    b = selection(fit,sparse=TRUE)
    coeff = data$coef
    index = which(coeff!=0)
    pos = which(b != 0)
    tp = length(intersect(index, pos))
    fp = length(pos) - tp
    list(tp=tp, fp=fp)
    
    # Prediction
    prediction=predict_mixedBayes(fit,y,X,e,g,k,slope=TRUE,loss = "L1")
    prediction

#### Example.3 (alternative: non-robust sparse bi-level selection under random intercept -and- slope model)

    fit = mixedBayes(y,e,X,g,k,robust=FALSE, quant = NULL,structure = "bilevel")
    
    # Estimated coefficients(posterior median)
    fit$coefficient
    
    # Identification
    b = selection(fit,sparse=TRUE)
    coeff = data$coef
    index = which(coeff!=0)
    pos = which(b != 0)
    tp = length(intersect(index, pos))
    fp = length(pos) - tp
    list(tp=tp, fp=fp)
    
    # Prediction
    prediction=predict_mixedBayes(fit,y,X,e,g,k,slope=TRUE,loss = "L2")
    prediction
    
#### Example.4 (alternative: robust bi-level selection under random intercept -and- slope model)

    fit = mixedBayes(y,e,X,g,k,robust=TRUE,sparse = FALSE,structure = "bilevel")
    
    # Estimated coefficients(posterior median)
    fit$coefficient
    
    # Identification
    b = selection(fit,sparse=FALSE)
    coeff = data$coef
    index = which(coeff!=0)
    pos = which(b != 0)
    tp = length(intersect(index, pos))
    fp = length(pos) - tp
    list(tp=tp, fp=fp)
    
    # Prediction
    prediction=predict_mixedBayes(fit,y,X,e,g,k,slope=TRUE,loss = "L1")
    prediction
    
## Data generation under random intercept model with t(2) error

    Data <- function (n,p,k,q,quant){
    sigma2=1
    # Generate genetic factors
    sig = matrix(0,p,p)
    for (i in 1:p)
    {
    for(j in 1:p)
    {
      sig[i,j] = 0.5^abs(i-j)
    }
    }
  
    g = mvrnorm(n,rep(0,p),sig)
    g = as.matrix(g)
    g = scale(g)
  
    # True main effects for genetic variables 
    beta_true = rep(0,p)
    beta_true[c(2,4,7,12)] = runif(4,0.4,0.8)
  
    # Generate environmental factors (a group of 3 dummy variables)
    group <- sample(0:3, size = n, replace = TRUE)
  
    e1 <- as.numeric(group == 1)
    e2 <- as.numeric(group == 2)
    e3 <- as.numeric(group == 3)
  
    e <- cbind(e1, e2, e3)
    e <- scale(e)
  
    # Fixed effects for environmental main effects
    alpha1= runif(q,0.4,0.8)
  
    # Fixed effects for time (polynomial terms)
    alpha2= runif(3,0.4,0.8)
  
    # Interaction terms
    w = c()
  
    for (i in 1:ncol(g))
    {
    
    w = cbind(w,g[,i]*e)
    
    }
  
    # True interaction effects
    eta_true <- rep(0, p * q)
    nz_block <- list(4:6, 10:12, 16:18, 19:21, 34:36, 43:45)
    for (idx in nz_block) {
     eta_true[idx] <- runif(q, 0.4, 0.8)
    }
  
    # Combine all coefficients
    betas_true <- c(beta_true, eta_true)
  
    #  Random effects design 
   
    z <- rep(1, k)
  
    # fixed-effect design for time
    xi <- cbind(1, 1:k, (1:k)^2)
    X <- do.call(rbind, replicate(n, xi, simplify = FALSE))
  
    # Generate response 
    y <- matrix(0, n, k)
    for (i in 1:n) {
    ata <- runif(1,0,1)
    ei <- matrix(rep(e[i, ], each = k), nrow = k)
    gi <- matrix(rep(g[i, ], each = k), nrow = k)
    wi <- matrix(rep(w[i, ], each = k), nrow = k)
    error <- rt(k, 2)
    error <- error -quantile(error, probs = quant)
    y[i, ] <- ei %*% alpha1 +xi %*% alpha2 +gi %*% beta_true +wi %*% eta_true +z * ata + error
    }
  
    # Convert to long format
    y = reformat(k,y,type="r");g = reformat(k,g,type="d");e = reformat(k,e,type="d")
    dat <- list(y = y, g = g, e  = e, X  = X, coef = betas_true)
    return (dat)
    }

    library(MASS)
    library(mixedBayes)
    n=200;p=100;q=3;k=5;quant=0.5
    data = Data(n,p,k,q,quant)
    y = data$y
    e = data$e
    g = data$g
    X = data$X
    
#### Example.1 (proposed method: robust sparse bi-level selection under random intercept model)

    fit = mixedBayes(y,e,X,g,k,slope=FALSE, structure="bilevel")
    
    # Estimated coefficients(posterior median)
    fit$coefficient
    
    # Identification
    b = selection(fit,sparse=TRUE)
    coeff = data$coef
    index = which(coeff!=0)
    pos = which(b != 0)
    tp = length(intersect(index, pos))
    fp = length(pos) - tp
    list(tp=tp, fp=fp)
    
    # Prediction
    prediction=predict_mixedBayes(fit,y,X,e,g,k,slope=FALSE,loss = "L1")
    prediction
    
#### Example.2 (alternative: robust sparse individual level selection under random intercept model)

    fit = mixedBayes(y,e,X,g,k,slope=FALSE, structure="individual")
    
    # Estimated coefficients(posterior median)
    fit$coefficient
    
    # Identification
    b = selection(fit,sparse=TRUE)
    coeff = data$coef
    index = which(coeff!=0)
    pos = which(b != 0)
    tp = length(intersect(index, pos))
    fp = length(pos) - tp
    list(tp=tp, fp=fp)
    
    # Prediction
    prediction=predict_mixedBayes(fit,y,X,e,g,k,slope=FALSE,loss = "L1")
    prediction

#### Example.3 (alternative: non-robust sparse bi-level selection under random intercept model)

    fit = mixedBayes(y,e,X,g,k,slope=FALSE,robust=FALSE, quant = NULL,structure = "bilevel")
    
    # Estimated coefficients(posterior median)
    fit$coefficient
    
    # Identification
    b = selection(fit,sparse=TRUE)
    coeff = data$coef
    index = which(coeff!=0)
    pos = which(b != 0)
    tp = length(intersect(index, pos))
    fp = length(pos) - tp
    list(tp=tp, fp=fp)
    
    # Prediction
    prediction=predict_mixedBayes(fit,y,X,e,g,k,slope=FALSE,loss = "L2")
    prediction
    
#### Example.4 (alternative: robust bi-level selection under random intercept model)

    fit = mixedBayes(y,e,X,g,k,slope=FALSE,robust=TRUE,sparse = FALSE,structure = "bilevel")
    
    # Estimated coefficients(posterior median)
    fit$coefficient
    
    # Identification
    b = selection(fit,sparse=FALSE)
    coeff = data$coef
    index = which(coeff!=0)
    pos = which(b != 0)
    tp = length(intersect(index, pos))
    fp = length(pos) - tp
    list(tp=tp, fp=fp)
    
    # Prediction
    prediction=predict_mixedBayes(fit,y,X,e,g,k,slope=FALSE,loss = "L1")
    prediction
  

## Methods

This package provides implementation for methods proposed in

  - Fan, K., Jiang, Y., Ma, S., Wang, W. and Wu, C. (2025). Robust Sparse Bayesian Regression for Longitudinal Gene-Environment Interactions. [Journal of the Royal Statistical Society Series C: Applied Statistics, 74(5), 1372–1394.](https://doi.org/10.1093/jrsssc/qlaf027)

#' This function changes the format of the longitudinal data from wide format to long format
#'
#' @param k the number of repeated measurement.
#' @param data either the response matrix or the predictor matrix.
#' @param type "r" for response matrix, "d" for design matrix.
#' @return the reformatted response vector or predictor matrix.
#' @usage reformat(k,data,type="r")
#' @export
reformat <- function(k, data, type = "r") {

  if (length(k) != 1 || !is.numeric(k) || is.na(k) || k <= 0 || k %% 1 != 0) {
    stop("k must be a positive integer.")
  }

  if (length(type) != 1 || !is.character(type) || is.na(type) ||
      !(type %in% c("r", "d"))) {
    stop("type must be exactly 'r' or 'd'.")
  }

  if (!is.matrix(data)) {
    data <- as.matrix(data)
  }

  n <- nrow(data)

  if (type == "r") {

    if (ncol(data) != k) {
      stop("For type = 'r', data must be an n x k response matrix.")
    }

    out <- as.vector(t(data))

  } else if (type == "d") {

    if (ncol(data) == k) {
      stop("For type = 'd', data should not have ncol = k. Did you pass a response matrix?")
    }

    out <- data[rep(seq_len(n), each = k), , drop = FALSE]
  }

  return(out)
}

#' Make predictions from a mixedBayes object
#'
#' @param object a mixedBayes object.
#' @param y a numeric vector of repeated-measure responses in long format.
#'   The current version only supports continuous response.
#' @param e the long-format design matrix for environment/treatment effects. In applications,
#'   this is a group of dummy variables encoding treatment levels.
#' @param X the long-format design matrix, including an intercept and optionally
#'   time-related covariates.
#' @param g the long-format matrix of genetic predictors.
#'
#' The interaction terms between genetic and environmental factors (G×E) are constructed internally
#' within the function and therefore do not need to be provided by the user.
#'
#' @param k integer. Number of repeated measurements per subject.
#' @param slope logical flag. If TRUE, random intercept-and-slope model will be used.
#' @param loss character string specifying the prediction loss function.
#'        "L1" for mean absolute error;
#'        "L2" for mean squared error.
#'
#'
#' @usage predict_mixedBayes(object, y, X, e, g, k, slope, loss)
#' @return an object of class `mixedBayes.pred' is returned, which is a list with components:
#' \item{pred_error}{prediction error.}
#' \item{y_hat}{predicted values of the repeated measured responses.}
#'
#' @rdname predict_mixedBayes
#' @seealso \code{\link{mixedBayes}}
#'
#' @examples
#' data(data)
#'
#' fit <- mixedBayes(y, e, X, g, k, structure = "bilevel")
#' pred1 <- predict_mixedBayes(fit, y, X, e, g, k, slope = TRUE, loss = "L1")
#' print(pred1$pred_error)
#' fit <- mixedBayes(y, e, X, g, k, robust =FALSE, quant =NULL,structure = "bilevel")
#' pred2 <- predict_mixedBayes(fit, y, X, e, g, k, slope = TRUE, loss = "L2")
#' print(pred2$pred_error)
#'
#' @export

predict_mixedBayes <- function(object, y, X, e, g, k,
                               slope = TRUE,
                               loss = "L1") {
  if (length(k) != 1 || !is.numeric(k) || is.na(k) || k <= 0 || k %% 1 != 0) {
    stop("k must be a positive integer.")
  }
  if (!is.logical(slope) || length(slope) != 1 || is.na(slope)) {
    stop("slope must be TRUE or FALSE.")
  }

  n  <- length(y)
  if (n %% k != 0) {
    stop("length(y) must be divisible by k.")
  }

  if (nrow(X) != n || nrow(e) != n || nrow(g) != n) {
    stop("X, e, and g must all have the same number of rows as length(y).")
  }

  n1 <- n / k

  Zblock <- make_Zblock(k, n1, slope)
  m = ncol(g)
  w = c()

  for (i in 1:m)
  {

    w = cbind(w,g[,i]*e)

  }

  y_hat <- X %*% object$coefficient$X +
    e %*% object$coefficient$treatment +
    g %*% object$coefficient$main +
    w %*% object$coefficient$interaction +
    Zblock %*% as.vector(object$coefficient$random)

  if (loss == "L1") {
    pred_error <- mean(abs(y - y_hat))
  } else if (loss == "L2") {
    pred_error <- mean((y - y_hat)^2)
  } else {
    stop("loss must be either 'L1' or 'L2'.")
  }

  mixedBayes.pred <- list(
    y_hat = y_hat,
    pred_error = pred_error,
    loss = loss
  )

  class(mixedBayes.pred) <- "mixedBayes.pred"

  return(mixedBayes.pred)
}

#' Variable selection for a mixedBayes object
#'
#' @param obj mixedBayes object.
#' @param sparse logical flag. If TRUE, spike-and-slab priors will be used to shrink coefficients of irrelevant covariates to zero exactly.
#'
#' @details If sparse, the median probability model (MPM) (Barbieri and Berger, 2004) is used to identify predictors that are significantly associated
#' with the response variable. Otherwise, variable selection is based on 95\% credible interval.
#' Please check the references for more details about the variable selection.
#'
#' @references
#' Ren, J., Zhou, F., Li, X., Ma, S., Jiang, Y. and Wu, C. (2023). Robust Bayesian variable selection for gene-environment interactions.
#' {\emph{Biometrics},79(2),684-694 } \doi{10.1111/biom.13670}
#'
#' Barbieri, M.M. and Berger, J.O. (2004). Optimal predictive model selection. {\emph{Ann. Statist}, 32(3):870–897}
#'
#' @rdname selection
#' @return an object of class `selection' is returned, which is a list with component:
#' \item{index}{a vector of indicators of selected effects.}
#'
#' @seealso \code{\link{mixedBayes}}
#'
#' @examples
#' data(data)
#' ## sparse
#' fit = mixedBayes(y,e,X,g,k,structure="bilevel")
#' selected=selection(fit,sparse=TRUE)
#' selected
#'
#' \donttest{
#' ## non-sparse
#' fit = mixedBayes(y,e,X,g,k,sparse=FALSE,structure="bilevel")
#' selected=selection(fit,sparse=FALSE)
#' selected
#' }
#'
#' @export
selection <- function(obj, sparse) {
  if (!inherits(obj, "mixedBayes")) {
    stop("obj must be a 'mixedBayes' object.")
  }

  if (!is.logical(sparse) || length(sparse) != 1 || is.na(sparse)) {
    stop("sparse must be TRUE or FALSE.")
  }

  if (is.null(obj$sparse) || !is.logical(obj$sparse) || length(obj$sparse) != 1 || is.na(obj$sparse)) {
    stop("The mixedBayes object must contain a valid logical component 'sparse'.")
  }

  if (!identical(sparse, obj$sparse)) {
    stop(sprintf(
      "Mismatch detected: selection() was called with sparse = %s, but the model was fitted with sparse = %s.",
      sparse, obj$sparse
    ))
  }

  if (sparse) {
    index <- selection_sparse(obj)
  } else {
    index <- selection_nonsparse(obj)
  }

  out <- index
  return(out)
}

make_Zblock <- function(k, n1,slope=TRUE) {
  if(slope){
    k_1 = c(1:k)
    k_1 = k_1 - mean(k_1)
    z = cbind(rep(1,k),k_1)
  } else {
    z = as.matrix(rep(1,k))
  }
  c <- ncol(z)
  Zblock <- matrix(0, nrow = n1 * k, ncol = n1 * c)
  for (i in 1:n1) {
    rows <- ((i - 1) * k + 1):(i * k)
    cols <- ((i - 1) * c + 1):(i * c)
    Zblock[rows, cols] <- z
  }
  Zblock
}

#' @useDynLib mixedBayes, .registration = TRUE
#' @importFrom Rcpp sourceCpp
NULL

"_PACKAGE"
#' @keywords overview
#' @name mixedBayes-package
#' @title Bayesian Longitudinal Regularized Quantile Mixed Model
#' @aliases mixedBayes-package
#' @description In this package, we provide implementations of a set of high-dimensional robust Bayesian mixed-effect models to dissect longitudinal gene-environment interactions. The proposed method conducts robust Bayesian variable selection on both the main and interaction effects corresponding to individual and group levels (i.e. bi-level), respectively. Alternatively, selections only on individual levels by ignoring the group structure can also be performed. In addition, intra-cluster correlations among repeated measures are modeled via random intercept-and-slope and/or random intercept models. Imposing exact sparsity through spike-and-slab priors can be conducted on fixed effects with bi-level and/or individual level. In total, package mixedBayes provides implementations on 2 (robust and non-robust) × 2 ( types of fixed effects) × 2 ( types of random effects) × 2 (spike-and-slab or Laplacian priors) = 16 methods. Please read the details below for how to configure the method used.
#' @details The user friendly, integrated interface \strong{mixedBayes()} allows users to flexibly choose the fitting methods by specifying the following parameter:
#' \tabular{rl}{
#' slope: \tab whether to use random intercept-and-slope model or random intercept model.\cr\cr
#' robust: \tab whether to use robust or non-robust methods.\cr\cr
#' quant: \tab to specify different quantile levels when using robust methods.\cr\cr
#' structure: \tab whether to specify bi-level or individual level.\cr\cr
#' sparse: \tab whether to use the spike-and-slab priors to impose sparsity.
#' }
#'
#' The function mixedBayes() returns a mixedBayes object that contains the posterior estimates of each coefficients.
#' S3 generic functions selection()and print() are implemented for mixedBayes objects.
#' selection() takes a mixedBayes object and returns the variable selection results.
#'
#' @references
#' Fan, K., Jiang, Y., Ma, S., Wang, W. and Wu, C. (2025). Robust Sparse Bayesian Regression for Longitudinal Gene-Environment Interactions.
#' {\emph{Journal of the Royal Statistical Society Series C: Applied Statistics}, 74(5), 1372–1394} \doi{10.1093/jrsssc/qlaf027}
#'
#' Zhou, F., Ren, J.,  Li, G., Jiang, Y., Li, X., Wang, W. and Wu, C. (2019). Penalized Variable Selection for Lipid-Environment Interactions in a Longitudinal Lipidomics Study.
#' {\emph{Genes}, 10(12), 1002} \doi{10.3390/genes10121002}
#'
#' Zhou, F., Ren, J., Liu, Y., Li, X., Wang, W., and Wu, C. (2022). Interep: An r package for high-dimensional interaction analysis of the repeated measurement data.
#' {\emph{Genes}, 13(3), 544} \doi{10.3390/genes13030544}
#'
#' Zhou, F., Lu, X., Ren, J., Fan, K., Ma, S., and Wu, C. (2022). Sparse group variable selection for gene–environment interactions in the longitudinal study.
#' {\emph{Genetic epidemiology}, 46(5-6), 317-340} \doi{10.1002/gepi.22461}
#'
#' Ren, J., Zhou, F., Li, X., Ma, S., Jiang, Y. and Wu, C. (2023). Robust Bayesian variable selection for gene-environment interactions.
#' {\emph{Biometrics},79(2),684-694 } \doi{10.1111/biom.13670}
#'
#' Wu, C., and Ma, S. (2015). A selective review of robust variable selection with applications in bioinformatics.
#' {\emph{Briefings in Bioinformatics}, 16(5), 873–883} \doi{10.1093/bib/bbu046}
#'
#' Zhou, F., Ren, J., Lu, X., Ma, S. and Wu, C. (2021). Gene–Environment Interaction: a Variable Selection Perspective.
#' {\emph{Epistasis. Methods in Molecular Biology.} 2212:191–223} \doi{10.1007/978-1-0716-0947-7_13}
#'
#' Ren, J., Zhou, F., Li, X., Chen, Q., Zhang, H., Ma, S., Jiang, Y. and Wu, C. (2020) Semi-parametric Bayesian variable selection for gene-environment interactions.
#' {\emph{Statistics in Medicine}, 39: 617– 638} \doi{10.1002/sim.8434}
#'
#' Wu, C., Jiang, Y., Ren, J., Cui, Y. and Ma, S. (2018). Dissecting gene-environment interactions: A penalized robust approach accounting for hierarchical structures.
#' {\emph{Statistics in Medicine}, 37:437–456} \doi{10.1002/sim.7518}
#'
#' Wu, C., Cui, Y., and Ma, S. (2014). Integrative analysis of gene–environment interactions under a multi–response partially linear varying coefficient model.
#' {\emph{Statistics in Medicine}, 33(28), 4988–4998} \doi{10.1002/sim.6287}
#'
#' Wu, C., Zhong, P.S. and Cui, Y. (2013). High dimensional variable selection for gene-environment interactions.
#' {\emph{Technical Report. Michigan State University.}}
#'
#' @seealso \code{\link{mixedBayes}}
NULL

LONBGLSS_1 <- function(y,e,X,g,z,k,max.steps,sparse, structure,iterations, burn.in=NULL){
  n = nrow(g)
  m = ncol(g)
  w = c()

  for (i in 1:m)
  {

    w = cbind(w,g[,i]*e)

  }
  p = ncol(w)
  c = ncol(z)
  E = cbind(e,X)
  q = ncol(E)
  o = ncol(X)
  n1 = n/k
  hatAta=matrix(c(rep(1,n1*c)),nrow=c)
  hatBeta = rep(1,m)
  hatEta = rep(1,p)
  hatAlpha = rep(1,q)
  hatInvTauSq1=rep(1,m)
  hatInvTauSq21=rep(1,p)
  hatInvTauSq22=rep(1,m)
  hatPiEta=1/2
  hatPiBeta=1/2
  invSigAlpha0 = rep(10^-3,q)
  hatLambdaSqStar1=1
  hatLambdaSqStar2=1
  hatSigmaSq=1
  hatPhiSq=1
  a0=aStar=1
  b0=bStar=1
  alpha=1
  gamma=1
  alpha1=1
  gamma1=1
  mu0=mu1=1
  nu0=nu1=1
  debugging=FALSE

  progress = ifelse(debugging, 10^(floor(log10(max.steps))-1), 0)

  if (sparse) {

    if (structure == "bilevel") {

      fit <- BGLSS_1(
        y, E, g, w, z, q, o, k, max.steps,
        hatAlpha, hatBeta, hatAta, hatEta, invSigAlpha0,
        hatInvTauSq1, hatInvTauSq22,
        hatPiBeta, hatPiEta,
        hatLambdaSqStar1, hatLambdaSqStar2,
        hatSigmaSq, hatPhiSq,
        a0, b0, aStar, bStar,
        alpha, gamma, alpha1, gamma1,
        mu0, mu1, nu0, nu1,
        progress
      )

    } else if (structure == "individual") {

      fit <- BLSS_1(
        y, E, g, w, z, q, k, max.steps,
        hatAlpha, hatBeta, hatAta, hatEta, invSigAlpha0,
        hatInvTauSq1, hatInvTauSq21,
        hatPiBeta, hatPiEta,
        hatLambdaSqStar1, hatLambdaSqStar2,
        hatSigmaSq, hatPhiSq,
        a0, b0, aStar, bStar,
        alpha, gamma, alpha1, gamma1,
        mu0, mu1, nu0, nu1,
        progress
      )

    }

  } else {

    if (structure == "bilevel") {

      fit <- BGL_1(
        y, E, g, w, q, o, k, max.steps,
        hatAlpha, hatBeta, hatEta, hatAta, z,
        invSigAlpha0,
        hatInvTauSq1, hatInvTauSq22,
        hatLambdaSqStar1, hatLambdaSqStar2,
        hatSigmaSq,
        a0, b0, aStar, bStar,
        hatPhiSq,
        alpha, gamma, alpha1, gamma1,
        progress
      )

    } else if (structure == "individual") {

      fit <- BL_1(
        y, E, g, w, q, k, max.steps,
        hatAlpha, hatBeta, hatEta, hatAta, z,
        invSigAlpha0,
        hatInvTauSq1, hatInvTauSq21,
        hatLambdaSqStar1, hatLambdaSqStar2,
        hatSigmaSq,
        a0, b0, aStar, bStar,
        hatPhiSq,
        alpha, gamma, alpha1, gamma1,
        progress
      )

    }

  }

  fit
}

selection_sparse = function(obj){
  sg1 = obj$posterior$GS.gamma2
  sg1[which(sg1!=0)]=1
  sg2 = obj$posterior$GS.gamma3
  sg2[which(sg2!=0)]=1
  main=c()
  for(j in 1:ncol(sg1)){
    t1=as.matrix(sg1[,j])
    q_t1 = mpm(t1)
    main = c(main,q_t1)
  }
  inter=c()
  for(j in 1:ncol(sg2)){
    t2=as.matrix(sg2[,j])
    q_t2 = mpm(t2)
    inter = c(inter,q_t2)
  }
  index = c(main,inter)
  index
}

LONRBGLSS_1 <- function(y,e,X,g,z,k,quant,max.steps,sparse, structure,iterations, burn.in=NULL){
  n = nrow(g)
  m = ncol(g)
  w = c()

  for (i in 1:m)
  {

    w = cbind(w,g[,i]*e)

  }
  p = ncol(w)
  E = cbind(e,X)
  o = ncol(X)
  q = ncol(E)
  c = ncol(z)
  n1 = n/k
  hatTau=1
  hatV = rep(1,n)
  hatSg1 = rep(1,m)
  hatSg21= rep(1,p)
  hatSg22 = rep(1,m)
  xi1=(1-2*quant)/(quant*(1-quant))
  xi2 = sqrt(2/(quant*(1-quant)))
  hatEtaSq1=1
  hatEtaSq2=1
  r1=1
  r2=1
  a=1
  b=1
  hatAta=matrix(c(rep(1,n1*c)),nrow=c)
  hatBeta = rep(1,m)
  hatEta1 = rep(1,p)
  hatEta2 = matrix(c(rep(1,p)),nrow=q-o)
  hatAlpha = rep(1,q)
  invSigAlpha0 = diag(rep(10^-3,q))
  alpha1=0
  gamma1=0
  hatPhiSq=1
  progress=0
  hatPi1=1/2
  hatPi2=1/2
  sh1=1
  sh0=1
  debugging=FALSE

  progress = ifelse(debugging, 10^(floor(log10(max.steps))-1), 0)

  if (sparse) {

    if (structure == "bilevel") {

      fit <- RBGLSS_1(
        y, E, g, w, max.steps, q, o, k,
        hatBeta, hatEta2, hatAlpha, hatAta, z,
        hatTau, hatV, hatSg1, hatSg22, invSigAlpha0,
        hatPi1, hatPi2, hatEtaSq1, hatEtaSq2,
        xi1, xi2, r1, r2, hatPhiSq,
        a, b, alpha1, gamma1, sh1, sh0, progress
      )

    } else if (structure == "individual") {

      fit <- RBLSS_1(
        y, E, g, w, max.steps, q, k,
        hatBeta, hatEta1, hatAlpha, hatAta, z,
        hatTau, hatV, hatSg1, hatSg21, invSigAlpha0,
        hatPi1, hatPi2, hatEtaSq1, hatEtaSq2,
        xi1, xi2, r1, r2, hatPhiSq,
        a, b, alpha1, gamma1, sh1, sh0, progress
      )

    }

  } else {

    if (structure == "bilevel") {

      fit <- RBGL_1(
        y, E, g, w, max.steps, q, o, k,
        hatBeta, hatEta2, hatAlpha, hatAta, z,
        hatTau, hatV, hatSg1, hatSg22, invSigAlpha0,
        hatEtaSq1, hatEtaSq2,
        xi1, xi2, r1, r2, hatPhiSq,
        a, b, alpha1, gamma1, progress
      )

    } else if (structure == "individual") {

      fit <- RBL_1(
        y, E, g, w, max.steps, q, k,
        hatBeta, hatEta1, hatAlpha, hatAta, z,
        hatTau, hatV, hatSg1, hatSg21, invSigAlpha0,
        hatEtaSq1, hatEtaSq2,
        xi1, xi2, r1, r2, hatPhiSq,
        a, b, alpha1, gamma1, progress
      )

    }
  }


  fit

}

#' simulated data for demonstrating the features of mixedBayes
#'
#' @docType data
#' @keywords datasets
#' @name data
#' @aliases data y e X g k coeff
#' @format The data object consists of seven components: y, e, X, g, k, and coeff.
#' The response y and the covariates e, X, and g are all provided in long format and share a common row ordering.
#' The component coeff contains the true parameter values (main and interaction effects) used to generate y.
#'
#' @details
#'
#' \strong{The data and model setting}
#'
#' Consider a longitudinal study on \eqn{n} subjects with \eqn{k} repeated measurement for each subject. Let \eqn{Y_{ij}} be the measurement for the \eqn{i}th subject at each time point \eqn{j}(\eqn{1\leq i \leq n, 1\leq j \leq k}) .We use the \eqn{m}-dimensional vector \eqn{\boldsymbol{G_{ij}}} to denote measurements of genetic factors for the \eqn{i}th subject at time point \eqn{j}, where \eqn{\boldsymbol{G_{ij}} = (G_{ij1},...,G_{ijm})^\top}. Also, we use \eqn{p}-dimensional vector \eqn{\boldsymbol{E_{ij}}} to denote the environmental/treatment factors, where \eqn{\boldsymbol{E_{ij}} = (E_{ij1},...,E_{ijp})^\top}. \eqn{\boldsymbol{X_{ij}} = (1, \boldsymbol{T^\top_{ij}})^\top}, where \eqn{\boldsymbol{T_{ij}}} is a vector of time effects . \eqn{\boldsymbol{Z_{ij}}} is a \eqn{h \times 1} covariate associated with random effects and \eqn{\boldsymbol{\alpha_{i,\theta}}} is a \eqn{h\times 1} vector of random effects. In a typical one-way repeated measure ANOVA with a fixed number (say four) of factor levels, the environmental (or treatment) factor is modeled as a group of three dummy variables. Therefore, gene-environment (or treatment) interaction leads to variable selections on individual levels (main effects) and group levels (interaction effects) simultaneously. Considering the genetics factors, environmental (or treatment) factors and their interactions that are jointly associated with the longitudinal phenotype, we have the following mixed-effects model at a given quantile level \eqn{\theta}, (\eqn{0 < \theta < 1}):
#' \deqn{Y_{ij} = \boldsymbol{X^\top_{ij}}\boldsymbol{\gamma_{0,\theta}}+\boldsymbol{E^\top_{ij}}\boldsymbol{\gamma_{1,\theta}}+\boldsymbol{G^\top_{ij}}\boldsymbol{\gamma_{2,\theta}}+(\boldsymbol{G_{ij}}\bigotimes \boldsymbol{E_{ij}})^\top\boldsymbol{\gamma_{3,\theta}}+\boldsymbol{Z^\top_{ij}}\boldsymbol{\alpha_{i,\theta}}+\epsilon_{ij,\theta}.}
#' where \eqn{\boldsymbol{\gamma_{1,\theta}}},\eqn{\boldsymbol{\gamma_{2,\theta}}},\eqn{\boldsymbol{\gamma_{3,\theta}}} are \eqn{p},\eqn{m} and \eqn{mp} dimensional vectors that represent the coefficients of the environmental effects, the genetic effects and interaction effects, respectively. In addition, \eqn{\boldsymbol{\gamma_{0,\theta}}} is the coefficient vector for \eqn{\boldsymbol{X_{ij}}}.
#' The gene–environment interactions that can be expressed as a Kronecker product between the two types of main effects as a \eqn{mp}-dimensional vector:
#' \deqn{\boldsymbol{G_{ij}}\bigotimes \boldsymbol{E_{ij}} = [G_{ij1}E_{ij1},G_{ij1}E_{ij2},...,G_{ij1}E_{ijp},G_{ij2}E_{ij1},...,G_{ijm}E_{ijp}]^\top.}
#'
#' The above model also includes \eqn{\boldsymbol{Z_{ij}}} with random effects \eqn{\boldsymbol{\alpha_{i,\theta}}} to account for intra-correlations among repeated measurements.
#' The \eqn{h \times 1} vector \eqn{\boldsymbol{Z_{ij}}} corresponds to the random intercept–slope model and random intercept model under \eqn{h = 2} and 1, respectively. The model error \eqn{\epsilon_{ij,\theta}}’s are independent with the \eqn{\theta}th quantile being zero.
#'
#' Without loss of generality, we suppress the subscript \eqn{\theta} of the regression coefficient vectors for both fixed and random effects from now on for simplicity of notation.
#'
#' In this example, we generate data under random intercept-and-slope model.
#'
#' @examples
#' data(data)
#' length(y)
#' dim(g)
#' dim(e)
#' print(k)
#' print(X)
#' print(coeff)
#'
#' @seealso \code{\link{mixedBayes}}
NULL

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

BGL <- function(y, e, g, w, q, o, k, maxSteps, hatM, hatR0, hatRStar, hatAta, z, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, a0, b0, aStar, bStar, Phi1Sq, Phi2Sq, alpha, gamma, alpha1, gamma1, progress) {
    .Call(`_mixedBayes_BGL`, y, e, g, w, q, o, k, maxSteps, hatM, hatR0, hatRStar, hatAta, z, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, a0, b0, aStar, bStar, Phi1Sq, Phi2Sq, alpha, gamma, alpha1, gamma1, progress)
}

BGL_1 <- function(y, e, g, w, q, o, k, maxSteps, hatM, hatR0, hatRStar, hatAta, z, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, a0, b0, aStar, bStar, Phi1Sq, alpha, gamma, alpha1, gamma1, progress) {
    .Call(`_mixedBayes_BGL_1`, y, e, g, w, q, o, k, maxSteps, hatM, hatR0, hatRStar, hatAta, z, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, a0, b0, aStar, bStar, Phi1Sq, alpha, gamma, alpha1, gamma1, progress)
}

BGLSS <- function(y, e, g, w, z, q, o, k, maxSteps, hatM, hatR0, hatAta, hatRStar, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatPi0, hatPiStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, Phi1Sq, Phi2Sq, a0, b0, aStar, bStar, alpha, gamma, alpha1, gamma1, mu0, muStar, nu0, nuStar, progress) {
    .Call(`_mixedBayes_BGLSS`, y, e, g, w, z, q, o, k, maxSteps, hatM, hatR0, hatAta, hatRStar, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatPi0, hatPiStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, Phi1Sq, Phi2Sq, a0, b0, aStar, bStar, alpha, gamma, alpha1, gamma1, mu0, muStar, nu0, nuStar, progress)
}

BGLSS_1 <- function(y, e, g, w, z, q, o, k, maxSteps, hatM, hatR0, hatAta, hatRStar, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatPi0, hatPiStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, Phi1Sq, a0, b0, aStar, bStar, alpha, gamma, alpha1, gamma1, mu0, muStar, nu0, nuStar, progress) {
    .Call(`_mixedBayes_BGLSS_1`, y, e, g, w, z, q, o, k, maxSteps, hatM, hatR0, hatAta, hatRStar, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatPi0, hatPiStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, Phi1Sq, a0, b0, aStar, bStar, alpha, gamma, alpha1, gamma1, mu0, muStar, nu0, nuStar, progress)
}

BL <- function(y, e, g, w, q, k, maxSteps, hatAlpha, hatBeta, hatEta, hatAta, z, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, a0, b0, aStar, bStar, Phi1Sq, Phi2Sq, alpha, gamma, alpha1, gamma1, progress) {
    .Call(`_mixedBayes_BL`, y, e, g, w, q, k, maxSteps, hatAlpha, hatBeta, hatEta, hatAta, z, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, a0, b0, aStar, bStar, Phi1Sq, Phi2Sq, alpha, gamma, alpha1, gamma1, progress)
}

BL_1 <- function(y, e, g, w, q, k, maxSteps, hatAlpha, hatBeta, hatEta, hatAta, z, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, a0, b0, aStar, bStar, Phi1Sq, alpha, gamma, alpha1, gamma1, progress) {
    .Call(`_mixedBayes_BL_1`, y, e, g, w, q, k, maxSteps, hatAlpha, hatBeta, hatEta, hatAta, z, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, a0, b0, aStar, bStar, Phi1Sq, alpha, gamma, alpha1, gamma1, progress)
}

BLSS <- function(y, e, g, w, z, q, k, maxSteps, hatAlpha, hatBeta, hatAta, hatEta, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatPi0, hatPiStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, Phi1Sq, Phi2Sq, a0, b0, aStar, bStar, alpha, gamma, alpha1, gamma1, mu0, muStar, nu0, nuStar, progress) {
    .Call(`_mixedBayes_BLSS`, y, e, g, w, z, q, k, maxSteps, hatAlpha, hatBeta, hatAta, hatEta, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatPi0, hatPiStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, Phi1Sq, Phi2Sq, a0, b0, aStar, bStar, alpha, gamma, alpha1, gamma1, mu0, muStar, nu0, nuStar, progress)
}

BLSS_1 <- function(y, e, g, w, z, q, k, maxSteps, hatAlpha, hatBeta, hatAta, hatEta, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatPi0, hatPiStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, Phi1Sq, a0, b0, aStar, bStar, alpha, gamma, alpha1, gamma1, mu0, muStar, nu0, nuStar, progress) {
    .Call(`_mixedBayes_BLSS_1`, y, e, g, w, z, q, k, maxSteps, hatAlpha, hatBeta, hatAta, hatEta, hatInvSigM0, hatInvTauSq0, hatInvTauSqStar, hatPi0, hatPiStar, hatLambdaSq0, hatLambdaSqStar, hatSigmaSq, Phi1Sq, a0, b0, aStar, bStar, alpha, gamma, alpha1, gamma1, mu0, muStar, nu0, nuStar, progress)
}

RBGL <- function(y, e, g, w, maxSteps, q, o, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, Phi2Sq, a, b, alpha1, gamma1, progress) {
    .Call(`_mixedBayes_RBGL`, y, e, g, w, maxSteps, q, o, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, Phi2Sq, a, b, alpha1, gamma1, progress)
}

RBGL_1 <- function(y, e, g, w, maxSteps, q, o, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, a, b, alpha1, gamma1, progress) {
    .Call(`_mixedBayes_RBGL_1`, y, e, g, w, maxSteps, q, o, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, a, b, alpha1, gamma1, progress)
}

RBGLSS <- function(y, e, g, w, maxSteps, q, o, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatPi1, hatPi2, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, Phi2Sq, a, b, alpha1, gamma1, sh1, sh0, progress) {
    .Call(`_mixedBayes_RBGLSS`, y, e, g, w, maxSteps, q, o, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatPi1, hatPi2, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, Phi2Sq, a, b, alpha1, gamma1, sh1, sh0, progress)
}

RBGLSS_1 <- function(y, e, g, w, maxSteps, q, o, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatPi1, hatPi2, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, a, b, alpha1, gamma1, sh1, sh0, progress) {
    .Call(`_mixedBayes_RBGLSS_1`, y, e, g, w, maxSteps, q, o, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatPi1, hatPi2, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, a, b, alpha1, gamma1, sh1, sh0, progress)
}

RBL <- function(y, e, g, w, maxSteps, q, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, Phi2Sq, a, b, alpha1, gamma1, progress) {
    .Call(`_mixedBayes_RBL`, y, e, g, w, maxSteps, q, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, Phi2Sq, a, b, alpha1, gamma1, progress)
}

RBL_1 <- function(y, e, g, w, maxSteps, q, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, a, b, alpha1, gamma1, progress) {
    .Call(`_mixedBayes_RBL_1`, y, e, g, w, maxSteps, q, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, a, b, alpha1, gamma1, progress)
}

RBLSS <- function(y, e, g, w, maxSteps, q, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatPi1, hatPi2, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, Phi2Sq, a, b, alpha1, gamma1, sh1, sh0, progress) {
    .Call(`_mixedBayes_RBLSS`, y, e, g, w, maxSteps, q, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatPi1, hatPi2, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, Phi2Sq, a, b, alpha1, gamma1, sh1, sh0, progress)
}

RBLSS_1 <- function(y, e, g, w, maxSteps, q, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatPi1, hatPi2, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, a, b, alpha1, gamma1, sh1, sh0, progress) {
    .Call(`_mixedBayes_RBLSS_1`, y, e, g, w, maxSteps, q, k, hatBeta, hatEta, hatAlpha, hatAta, z, hatTau, hatV, hatSg1, hatSg2, invSigAlpha0, hatPi1, hatPi2, hatEtaSq1, hatEtaSq2, xi1, xi2, r1, r2, Phi1Sq, a, b, alpha1, gamma1, sh1, sh0, progress)
}

selection_nonsparse = function(obj){
  sg1 = obj$posterior$GS.gamma2
  sg2 = obj$posterior$GS.gamma3
  q_1=c()
  for(j in 1:ncol(sg1)){
    t1=as.matrix(sg1[,j])
    q_t1 = as.matrix(stats::quantile(t1,c(0.025,0.975)))
    q_1 = cbind(q_1,q_t1)

  }
  main = apply(q_1, 2, fun)
  q_2=c()
  for(j in 1:ncol(sg2)){
    t2=as.matrix(sg2[,j])
    q_t2 = as.matrix(stats::quantile(t2,c(0.025,0.975)))
    q_2 = cbind(q_2,q_t2)
  }
 inter = apply(q_2, 2, fun)
 index = c(main,inter)
 index
}

#' fit a Bayesian longitudinal regularized quantile mixed model
#'
#' @keywords models
#' @param y a numeric vector of repeated-measure responses in long format. The current version only supports continuous response.
#' @param e the long-format matrix for environmental/treatment effects. In applications, this corresponds to a set of dummy variables encoding treatment levels.
#' @param X the long-format matrix, including an intercept term and optionally time covariates.
#' @param g the long-format matrix of genetic predictors.
#' @param k a positive integer. Number of repeated measurements per subject.
#' @param iterations the number of MCMC iterations. The default value is 10,000.
#' @param burn.in the number of iterations for burn-in. If NULL, no burn-in is applied and all MCMC samples are retained. The default value is 5,000.
#' @param slope logical flag. If TRUE, random intercept-and-slope model will be used. Otherwise, random intercept model will be used. The default value is TRUE.
#' @param robust logical flag. If TRUE, robust methods will be used. Otherwise, non-robust methods will be used. The default value is TRUE.
#' @param quant the quantile level specified by users. Required when robust = TRUE. Ignored (set to NULL) when robust = FALSE. The default value is 0.5.
#' @param sparse logical flag. If TRUE, spike-and-slab priors will be adopted to impose exact sparsity on regression coefficients. Otherwise, Laplacian shrinkage will be adopted. The default value is TRUE.
#' @param structure two choices are available. "bilevel" performs selection on both main effects and interaction effects corresponding to individual and group levels, whereas "individual" performs selections only on individual levels by ignoring the group structure.
#' @return An object of class \code{"mixedBayes"} is returned, which is a list with components:
#' \item{posterior}{Posterior samples for fixed effects and random effects.}
#' \item{coefficient}{Posterior median estimates of fixed effects and random effects.}
#' \item{sparse}{Logical value indicating whether spike-and-slab priors were used.}
#' \item{robust}{Logical value indicating whether the robust (quantile regression) model was used.}
#' \item{slope}{Logical value indicating whether a random intercept-and-slope model was used.}
#' \item{quant}{Quantile level used when \code{robust = TRUE}; otherwise \code{NULL}.}
#' \item{structure}{Character string specifying the selection structure ("bilevel" or "individual").}
#' \item{k}{Number of repeated measurements per subject.}
#' \item{iterations}{Total number of MCMC iterations.}
#' \item{burn.in}{Number of burn-in iterations.}
#'
#' @details
#' \strong{Data layout}
#'
#' Consider a longitudinal study with repeated measurements per subject, where each subject has the same number of repeated measurements.
#'
#' The response vector y and the design matrices X, e and g must all be provided in long format and share the same
#' row ordering. In practice, each row corresponds to one observation from a particular subject at a
#' particular time point.
#'
#' The interaction terms between genetic and environmental factors (G×E) are constructed internally
#' within the function and therefore do not need to be provided by the user.
#'
#'
#' \strong{Model}
#'
#' Consider the data model described in "\code{\link{data}}":
#' \deqn{Y_{ij} = \boldsymbol{X^\top_{ij}}\boldsymbol{\gamma_{0}}+\boldsymbol{E^\top_{ij}}\boldsymbol{\gamma_{1}}+\boldsymbol{G^\top_{ij}}\boldsymbol{\gamma_{2}}+(\boldsymbol{G_{ij}}\bigotimes \boldsymbol{E_{ij}})^\top\boldsymbol{\gamma_{3}}+\boldsymbol{Z^\top_{ij}}\boldsymbol{\alpha_{i}}+\epsilon_{ij}.}
#'
#' Here \eqn{\boldsymbol{\gamma_{0}}} is the coefficient vector for \eqn{\boldsymbol{X_{ij}}}, \eqn{\boldsymbol{\gamma_{1}}} is the coefficient vector for \eqn{\boldsymbol{E_{ij}}}, \eqn{\boldsymbol{\gamma_{2}}} is the coefficient vector for the genetic variants, and \eqn{\boldsymbol{\gamma_{3}}} is the coefficient vector for the interactions of the genetic variants with environment factors.
#'
#' where \eqn{\boldsymbol{\gamma_{1}}=(\gamma_{11},\dots,\gamma_{1p})^\top}, \eqn{\boldsymbol{\gamma_{2}}=(\gamma_{21},\dots,\gamma_{2m})^\top}, \eqn{\boldsymbol{\gamma_{3}}=(\boldsymbol{\gamma_{31}},\dots,\boldsymbol{\gamma_{3m}})^\top} where \eqn{\boldsymbol{\gamma_{3l}}=(\gamma_{3l1},\dots,\gamma_{3lp})^\top} for \eqn{l=1,\dots,m}.
#'
#' The subject-specific random effects \eqn{\boldsymbol{\alpha_i}} capture within-subject correlation. For random intercept-and-slope model, \eqn{\boldsymbol{Z^\top_{ij}} = (1,j)} and  \eqn{\boldsymbol{\alpha_{i}} = (\alpha_{i1},\alpha_{i2})^\top}. For random intercept model, \eqn{Z_{ij} = 1} and \eqn{\alpha_{i} = \alpha_{i1}}.
#'
#' When `structure=bilevel`(default), bi-level selection on main and interaction effects will be conducted corresponding to individual and group levels, respectively. When `structure="individual"`, selections only on individual levels by ignoring the group structure will be performed.
#'
#' When `slope=TRUE` (default), random intercept-and-slope model will be used as the mixed effects model. Otherwise, random intercept model will be used.
#'
#' When `sparse=TRUE` (default), spike-and-slab priors are imposed to identify important main and interaction effects. Otherwise, Laplacian shrinkage will be used.
#'
#' When `robust=TRUE` (default), the distribution of \eqn{\epsilon_{ij}} is defined as an asymmetric Laplace distribution with density.
#'
#' \eqn{
#' f(\epsilon_{ij}|\theta,\tau) = \theta(1-\theta)\exp\left\{-\tau\rho_{\theta}(\epsilon_{ij})\right\}
#' }, (\eqn{i=1,\dots,n,j=1,\dots,k }), which leads to a Bayesian formulation of quantile regression. Otherwise, \eqn{\epsilon_{ij}} follows a normal distribution.

#' \cr
#'
#' Please check the references for more details about the prior distributions.
#'
#' @seealso \code{\link{data}}
#'
#' @examples
#' data(data)
#'
#' ## default method (robust sparse bi-level selection under random intercept-and-slope model)

#' fit = mixedBayes(y,e,X,g,k,structure="bilevel")
#' fit$coefficient
#'
#'## Compute TP and FP
#'b = selection(fit,sparse=TRUE)
#'index = which(coeff!=0)
#'pos = which(b != 0)
#'tp = length(intersect(index, pos))
#'fp = length(pos) - tp
#'list(tp=tp, fp=fp)

#' \donttest{
#' ## alternative: robust sparse individual level selections under random intercept-and-slope model
#' fit = mixedBayes(y,e,X,g,k,structure="individual")
#' fit$coefficient
#'
#' ## alternative: non-robust sparse bi-level selection under random intercept-and-slope model
#' fit = mixedBayes(y,e,X,g,k,robust=FALSE, quant = NULL, structure="bilevel")
#' fit$coefficient
#'
#' ## alternative: robust sparse bi-level selection under random intercept model
#' fit = mixedBayes(y,e,X,g,k,slope=FALSE, structure="bilevel")
#' fit$coefficient
#'
#' }
#'
#' @export

mixedBayes <- function(y, e, X, g, k,
                       iterations = 10000,
                       burn.in = 5000,
                       slope = TRUE,
                       robust = TRUE,
                       quant = 0.5,
                       sparse = TRUE,
                       structure = "bilevel") {

  X <- as.matrix(X)
  e <- as.matrix(e)
  g <- as.matrix(g)
  y <- as.numeric(y)

  n <- length(y)
  E <- cbind(e, X)
  o <- ncol(X)
  q <- ncol(E)

  if (nrow(X) != n || nrow(e) != n || nrow(g) != n) {
    stop("X, e, and g must all have the same number of rows as length(y).")
  }

  if (length(k) != 1 || !is.numeric(k) || is.na(k) || k <= 0 || k %% 1 != 0) {
    stop("k must be a positive integer.")
  }

  if (n %% k != 0) {
    stop("length(y) must be divisible by k.")
  }

  if (!is.logical(slope) || length(slope) != 1 || is.na(slope)) {
    stop("slope must be TRUE or FALSE.")
  }

  if (!is.logical(robust) || length(robust) != 1 || is.na(robust)) {
    stop("robust must be TRUE or FALSE.")
  }

  if (!is.logical(sparse) || length(sparse) != 1 || is.na(sparse)) {
    stop("sparse must be TRUE or FALSE.")
  }

  if (length(structure) != 1 || !is.character(structure) || is.na(structure) ||
      !(structure %in% c("bilevel", "individual"))) {
    stop("structure must be either 'bilevel' or 'individual'.")
  }

  if (length(iterations) != 1 || !is.numeric(iterations) || is.na(iterations) ||
      iterations <= 0 || iterations %% 1 != 0) {
    stop("iterations must be a positive integer.")
  }

  if (is.null(burn.in)) {
    BI <- 0L
  } else if (length(burn.in) == 1 && is.numeric(burn.in) && !is.na(burn.in) &&
             burn.in >= 0 && burn.in %% 1 == 0) {
    BI <- as.integer(burn.in)
  } else {
    stop("burn.in must be NULL or a nonnegative integer.")
  }

  if (iterations <= BI) {
    stop("iterations must be larger than burn.in.")
  }

  if (robust) {
    if (is.null(quant) || length(quant) != 1 || !is.numeric(quant) || is.na(quant) ||
        quant <= 0 || quant >= 1) {
      stop("quant must be a single number between 0 and 1 when robust = TRUE.")
    }
  } else {
    if (!is.null(quant)) {
      stop("quant must be NULL when robust = FALSE.")
    }
  }

  if (slope) {
    k_1 <- seq_len(k)
    k_1 <- k_1 - mean(k_1)
    z <- cbind(rep(1, k), k_1)

    if (robust) {
      fit0 <- LONRBGLSS(y, e, X, g, z, k, quant, iterations, sparse, structure, iterations, burn.in)
    } else {
      fit0 <- LONBGLSS(y, e, X, g, z, k, iterations, sparse, structure, iterations, burn.in)
    }

  } else {
    z <- matrix(1, nrow = k, ncol = 1)

    if (robust) {
      fit0 <- LONRBGLSS_1(y, e, X, g, z, k, quant, iterations, sparse, structure, iterations, burn.in)
    } else {
      fit0 <- LONBGLSS_1(y, e, X, g, z, k, iterations, sparse, structure, iterations, burn.in)
    }
  }

  if (BI == 0) {
    out <- list(
      GS.gamma1 = fit0$GS.alpha[, 1:(q - o), drop = FALSE],
      GS.gamma0 = fit0$GS.alpha[, -(1:(q - o)), drop = FALSE],
      GS.gamma2 = fit0$GS.beta,
      GS.gamma3 = fit0$GS.eta,
      GS.alpha  = fit0$GS.ata
    )
  } else {
    burn_rows <- seq_len(BI)
    out <- list(
      GS.gamma1 = fit0$GS.alpha[-burn_rows, 1:(q - o), drop = FALSE],
      GS.gamma0 = fit0$GS.alpha[-burn_rows, -(1:(q - o)), drop = FALSE],
      GS.gamma2 = fit0$GS.beta[-burn_rows, , drop = FALSE],
      GS.gamma3 = fit0$GS.eta[-burn_rows, , drop = FALSE],
      GS.alpha  = fit0$GS.ata[-burn_rows, , drop = FALSE]
    )
  }

  coeff.treatment   <- apply(out$GS.gamma1, 2, stats::median)
  coeff.X           <- apply(out$GS.gamma0, 2, stats::median)
  coeff.main        <- apply(out$GS.gamma2, 2, stats::median)
  coeff.interaction <- apply(out$GS.gamma3, 2, stats::median)
  coeff.random      <- apply(out$GS.alpha, 2, stats::median)
  coeff.random      <- matrix(coeff.random, ncol = n / k)

  coefficient <- list(
    treatment   = coeff.treatment,
    X           = coeff.X,
    main        = coeff.main,
    interaction = coeff.interaction,
    random      = coeff.random
  )

  fit <- list(
    posterior   = out,
    coefficient = coefficient,
    sparse      = sparse,
    robust      = robust,
    slope       = slope,
    quant       = quant,
    structure   = structure,
    k           = k,
    iterations  = iterations,
    burn.in     = BI
  )

  class(fit) <- "mixedBayes"

  return(fit)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mixedBayes-package.R
\name{mixedBayes-package}
\alias{mixedBayes-package}
\title{Bayesian Longitudinal Regularized Quantile Mixed Model}
\description{
In this package, we provide implementations of a set of high-dimensional robust Bayesian mixed-effect models to dissect longitudinal gene-environment interactions. The proposed method conducts robust Bayesian variable selection on both the main and interaction effects corresponding to individual and group levels (i.e. bi-level), respectively. Alternatively, selections only on individual levels by ignoring the group structure can also be performed. In addition, intra-cluster correlations among repeated measures are modeled via random intercept-and-slope and/or random intercept models. Imposing exact sparsity through spike-and-slab priors can be conducted on fixed effects with bi-level and/or individual level. In total, package mixedBayes provides implementations on 2 (robust and non-robust) × 2 ( types of fixed effects) × 2 ( types of random effects) × 2 (spike-and-slab or Laplacian priors) = 16 methods. Please read the details below for how to configure the method used.
}
\details{
The user friendly, integrated interface \strong{mixedBayes()} allows users to flexibly choose the fitting methods by specifying the following parameter:
\tabular{rl}{
slope: \tab whether to use random intercept-and-slope model or random intercept model.\cr\cr
robust: \tab whether to use robust or non-robust methods.\cr\cr
quant: \tab to specify different quantile levels when using robust methods.\cr\cr
structure: \tab whether to specify bi-level or individual level.\cr\cr
sparse: \tab whether to use the spike-and-slab priors to impose sparsity.
}

The function mixedBayes() returns a mixedBayes object that contains the posterior estimates of each coefficients.
S3 generic functions selection()and print() are implemented for mixedBayes objects.
selection() takes a mixedBayes object and returns the variable selection results.
}
\references{
Fan, K., Jiang, Y., Ma, S., Wang, W. and Wu, C. (2025). Robust Sparse Bayesian Regression for Longitudinal Gene-Environment Interactions.
{\emph{Journal of the Royal Statistical Society Series C: Applied Statistics}, 74(5), 1372–1394} \doi{10.1093/jrsssc/qlaf027}

Zhou, F., Ren, J.,  Li, G., Jiang, Y., Li, X., Wang, W. and Wu, C. (2019). Penalized Variable Selection for Lipid-Environment Interactions in a Longitudinal Lipidomics Study.
{\emph{Genes}, 10(12), 1002} \doi{10.3390/genes10121002}

Zhou, F., Ren, J., Liu, Y., Li, X., Wang, W., and Wu, C. (2022). Interep: An r package for high-dimensional interaction analysis of the repeated measurement data.
{\emph{Genes}, 13(3), 544} \doi{10.3390/genes13030544}

Zhou, F., Lu, X., Ren, J., Fan, K., Ma, S., and Wu, C. (2022). Sparse group variable selection for gene–environment interactions in the longitudinal study.
{\emph{Genetic epidemiology}, 46(5-6), 317-340} \doi{10.1002/gepi.22461}

Ren, J., Zhou, F., Li, X., Ma, S., Jiang, Y. and Wu, C. (2023). Robust Bayesian variable selection for gene-environment interactions.
{\emph{Biometrics},79(2),684-694 } \doi{10.1111/biom.13670}

Wu, C., and Ma, S. (2015). A selective review of robust variable selection with applications in bioinformatics.
{\emph{Briefings in Bioinformatics}, 16(5), 873–883} \doi{10.1093/bib/bbu046}

Zhou, F., Ren, J., Lu, X., Ma, S. and Wu, C. (2021). Gene–Environment Interaction: a Variable Selection Perspective.
{\emph{Epistasis. Methods in Molecular Biology.} 2212:191–223} \doi{10.1007/978-1-0716-0947-7_13}

Ren, J., Zhou, F., Li, X., Chen, Q., Zhang, H., Ma, S., Jiang, Y. and Wu, C. (2020) Semi-parametric Bayesian variable selection for gene-environment interactions.
{\emph{Statistics in Medicine}, 39: 617– 638} \doi{10.1002/sim.8434}

Wu, C., Jiang, Y., Ren, J., Cui, Y. and Ma, S. (2018). Dissecting gene-environment interactions: A penalized robust approach accounting for hierarchical structures.
{\emph{Statistics in Medicine}, 37:437–456} \doi{10.1002/sim.7518}

Wu, C., Cui, Y., and Ma, S. (2014). Integrative analysis of gene–environment interactions under a multi–response partially linear varying coefficient model.
{\emph{Statistics in Medicine}, 33(28), 4988–4998} \doi{10.1002/sim.6287}

Wu, C., Zhong, P.S. and Cui, Y. (2013). High dimensional variable selection for gene-environment interactions.
{\emph{Technical Report. Michigan State University.}}
}
\seealso{
\code{\link{mixedBayes}}
}
\keyword{overview}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predict_mixedBayes.R
\name{predict_mixedBayes}
\alias{predict_mixedBayes}
\title{Make predictions from a mixedBayes object}
\usage{
predict_mixedBayes(object, y, X, e, g, k, slope, loss)
}
\arguments{
\item{object}{a mixedBayes object.}

\item{y}{a numeric vector of repeated-measure responses in long format.
The current version only supports continuous response.}

\item{X}{the long-format design matrix, including an intercept and optionally
time-related covariates.}

\item{e}{the long-format design matrix for environment/treatment effects. In applications,
this is a group of dummy variables encoding treatment levels.}

\item{g}{the long-format matrix of genetic predictors.

The interaction terms between genetic and environmental factors (G×E) are constructed internally
within the function and therefore do not need to be provided by the user.}

\item{k}{integer. Number of repeated measurements per subject.}

\item{slope}{logical flag. If TRUE, random intercept-and-slope model will be used.}

\item{loss}{character string specifying the prediction loss function.
"L1" for mean absolute error;
"L2" for mean squared error.}
}
\value{
an object of class `mixedBayes.pred' is returned, which is a list with components:
\item{pred_error}{prediction error.}
\item{y_hat}{predicted values of the repeated measured responses.}
}
\description{
Make predictions from a mixedBayes object
}
\examples{
data(data)

fit <- mixedBayes(y, e, X, g, k, structure = "bilevel")
pred1 <- predict_mixedBayes(fit, y, X, e, g, k, slope = TRUE, loss = "L1")
print(pred1$pred_error)
fit <- mixedBayes(y, e, X, g, k, robust =FALSE, quant =NULL,structure = "bilevel")
pred2 <- predict_mixedBayes(fit, y, X, e, g, k, slope = TRUE, loss = "L2")
print(pred2$pred_error)

}
\seealso{
\code{\link{mixedBayes}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/selection.R
\name{selection}
\alias{selection}
\title{Variable selection for a mixedBayes object}
\usage{
selection(obj, sparse)
}
\arguments{
\item{obj}{mixedBayes object.}

\item{sparse}{logical flag. If TRUE, spike-and-slab priors will be used to shrink coefficients of irrelevant covariates to zero exactly.}
}
\value{
an object of class `selection' is returned, which is a list with component:
\item{index}{a vector of indicators of selected effects.}
}
\description{
Variable selection for a mixedBayes object
}
\details{
If sparse, the median probability model (MPM) (Barbieri and Berger, 2004) is used to identify predictors that are significantly associated
with the response variable. Otherwise, variable selection is based on 95\% credible interval.
Please check the references for more details about the variable selection.
}
\examples{
data(data)
## sparse
fit = mixedBayes(y,e,X,g,k,structure="bilevel")
selected=selection(fit,sparse=TRUE)
selected

\donttest{
## non-sparse
fit = mixedBayes(y,e,X,g,k,sparse=FALSE,structure="bilevel")
selected=selection(fit,sparse=FALSE)
selected
}

}
\references{
Ren, J., Zhou, F., Li, X., Ma, S., Jiang, Y. and Wu, C. (2023). Robust Bayesian variable selection for gene-environment interactions.
{\emph{Biometrics},79(2),684-694 } \doi{10.1111/biom.13670}

Barbieri, M.M. and Berger, J.O. (2004). Optimal predictive model selection. {\emph{Ann. Statist}, 32(3):870–897}
}
\seealso{
\code{\link{mixedBayes}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reformat.R
\name{reformat}
\alias{reformat}
\title{This function changes the format of the longitudinal data from wide format to long format}
\usage{
reformat(k,data,type="r")
}
\arguments{
\item{k}{the number of repeated measurement.}

\item{data}{either the response matrix or the predictor matrix.}

\item{type}{"r" for response matrix, "d" for design matrix.}
}
\value{
the reformatted response vector or predictor matrix.
}
\description{
This function changes the format of the longitudinal data from wide format to long format
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{data}
\alias{data}
\alias{y}
\alias{e}
\alias{X}
\alias{g}
\alias{k}
\alias{coeff}
\title{simulated data for demonstrating the features of mixedBayes}
\format{
The data object consists of seven components: y, e, X, g, k, and coeff.
The response y and the covariates e, X, and g are all provided in long format and share a common row ordering.
The component coeff contains the true parameter values (main and interaction effects) used to generate y.
}
\description{
simulated data for demonstrating the features of mixedBayes
}
\details{
\strong{The data and model setting}

Consider a longitudinal study on \eqn{n} subjects with \eqn{k} repeated measurement for each subject. Let \eqn{Y_{ij}} be the measurement for the \eqn{i}th subject at each time point \eqn{j}(\eqn{1\leq i \leq n, 1\leq j \leq k}) .We use the \eqn{m}-dimensional vector \eqn{\boldsymbol{G_{ij}}} to denote measurements of genetic factors for the \eqn{i}th subject at time point \eqn{j}, where \eqn{\boldsymbol{G_{ij}} = (G_{ij1},...,G_{ijm})^\top}. Also, we use \eqn{p}-dimensional vector \eqn{\boldsymbol{E_{ij}}} to denote the environmental/treatment factors, where \eqn{\boldsymbol{E_{ij}} = (E_{ij1},...,E_{ijp})^\top}. \eqn{\boldsymbol{X_{ij}} = (1, \boldsymbol{T^\top_{ij}})^\top}, where \eqn{\boldsymbol{T_{ij}}} is a vector of time effects . \eqn{\boldsymbol{Z_{ij}}} is a \eqn{h \times 1} covariate associated with random effects and \eqn{\boldsymbol{\alpha_{i,\theta}}} is a \eqn{h\times 1} vector of random effects. In a typical one-way repeated measure ANOVA with a fixed number (say four) of factor levels, the environmental (or treatment) factor is modeled as a group of three dummy variables. Therefore, gene-environment (or treatment) interaction leads to variable selections on individual levels (main effects) and group levels (interaction effects) simultaneously. Considering the genetics factors, environmental (or treatment) factors and their interactions that are jointly associated with the longitudinal phenotype, we have the following mixed-effects model at a given quantile level \eqn{\theta}, (\eqn{0 < \theta < 1}):
\deqn{Y_{ij} = \boldsymbol{X^\top_{ij}}\boldsymbol{\gamma_{0,\theta}}+\boldsymbol{E^\top_{ij}}\boldsymbol{\gamma_{1,\theta}}+\boldsymbol{G^\top_{ij}}\boldsymbol{\gamma_{2,\theta}}+(\boldsymbol{G_{ij}}\bigotimes \boldsymbol{E_{ij}})^\top\boldsymbol{\gamma_{3,\theta}}+\boldsymbol{Z^\top_{ij}}\boldsymbol{\alpha_{i,\theta}}+\epsilon_{ij,\theta}.}
where \eqn{\boldsymbol{\gamma_{1,\theta}}},\eqn{\boldsymbol{\gamma_{2,\theta}}},\eqn{\boldsymbol{\gamma_{3,\theta}}} are \eqn{p},\eqn{m} and \eqn{mp} dimensional vectors that represent the coefficients of the environmental effects, the genetic effects and interaction effects, respectively. In addition, \eqn{\boldsymbol{\gamma_{0,\theta}}} is the coefficient vector for \eqn{\boldsymbol{X_{ij}}}.
The gene–environment interactions that can be expressed as a Kronecker product between the two types of main effects as a \eqn{mp}-dimensional vector:
\deqn{\boldsymbol{G_{ij}}\bigotimes \boldsymbol{E_{ij}} = [G_{ij1}E_{ij1},G_{ij1}E_{ij2},...,G_{ij1}E_{ijp},G_{ij2}E_{ij1},...,G_{ijm}E_{ijp}]^\top.}

The above model also includes \eqn{\boldsymbol{Z_{ij}}} with random effects \eqn{\boldsymbol{\alpha_{i,\theta}}} to account for intra-correlations among repeated measurements.
The \eqn{h \times 1} vector \eqn{\boldsymbol{Z_{ij}}} corresponds to the random intercept–slope model and random intercept model under \eqn{h = 2} and 1, respectively. The model error \eqn{\epsilon_{ij,\theta}}’s are independent with the \eqn{\theta}th quantile being zero.

Without loss of generality, we suppress the subscript \eqn{\theta} of the regression coefficient vectors for both fixed and random effects from now on for simplicity of notation.

In this example, we generate data under random intercept-and-slope model.
}
\examples{
data(data)
length(y)
dim(g)
dim(e)
print(k)
print(X)
print(coeff)

}
\seealso{
\code{\link{mixedBayes}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mixedBayes.R
\name{mixedBayes}
\alias{mixedBayes}
\title{fit a Bayesian longitudinal regularized quantile mixed model}
\usage{
mixedBayes(
  y,
  e,
  X,
  g,
  k,
  iterations = 10000,
  burn.in = 5000,
  slope = TRUE,
  robust = TRUE,
  quant = 0.5,
  sparse = TRUE,
  structure = "bilevel"
)
}
\arguments{
\item{y}{a numeric vector of repeated-measure responses in long format. The current version only supports continuous response.}

\item{e}{the long-format matrix for environmental/treatment effects. In applications, this corresponds to a set of dummy variables encoding treatment levels.}

\item{X}{the long-format matrix, including an intercept term and optionally time covariates.}

\item{g}{the long-format matrix of genetic predictors.}

\item{k}{a positive integer. Number of repeated measurements per subject.}

\item{iterations}{the number of MCMC iterations. The default value is 10,000.}

\item{burn.in}{the number of iterations for burn-in. If NULL, no burn-in is applied and all MCMC samples are retained. The default value is 5,000.}

\item{slope}{logical flag. If TRUE, random intercept-and-slope model will be used. Otherwise, random intercept model will be used. The default value is TRUE.}

\item{robust}{logical flag. If TRUE, robust methods will be used. Otherwise, non-robust methods will be used. The default value is TRUE.}

\item{quant}{the quantile level specified by users. Required when robust = TRUE. Ignored (set to NULL) when robust = FALSE. The default value is 0.5.}

\item{sparse}{logical flag. If TRUE, spike-and-slab priors will be adopted to impose exact sparsity on regression coefficients. Otherwise, Laplacian shrinkage will be adopted. The default value is TRUE.}

\item{structure}{two choices are available. "bilevel" performs selection on both main effects and interaction effects corresponding to individual and group levels, whereas "individual" performs selections only on individual levels by ignoring the group structure.}
}
\value{
An object of class \code{"mixedBayes"} is returned, which is a list with components:
\item{posterior}{Posterior samples for fixed effects and random effects.}
\item{coefficient}{Posterior median estimates of fixed effects and random effects.}
\item{sparse}{Logical value indicating whether spike-and-slab priors were used.}
\item{robust}{Logical value indicating whether the robust (quantile regression) model was used.}
\item{slope}{Logical value indicating whether a random intercept-and-slope model was used.}
\item{quant}{Quantile level used when \code{robust = TRUE}; otherwise \code{NULL}.}
\item{structure}{Character string specifying the selection structure ("bilevel" or "individual").}
\item{k}{Number of repeated measurements per subject.}
\item{iterations}{Total number of MCMC iterations.}
\item{burn.in}{Number of burn-in iterations.}
}
\description{
fit a Bayesian longitudinal regularized quantile mixed model
}
\details{
\strong{Data layout}

Consider a longitudinal study with repeated measurements per subject, where each subject has the same number of repeated measurements.

The response vector y and the design matrices X, e and g must all be provided in long format and share the same
row ordering. In practice, each row corresponds to one observation from a particular subject at a
particular time point.

The interaction terms between genetic and environmental factors (G×E) are constructed internally
within the function and therefore do not need to be provided by the user.


\strong{Model}

Consider the data model described in "\code{\link{data}}":
\deqn{Y_{ij} = \boldsymbol{X^\top_{ij}}\boldsymbol{\gamma_{0}}+\boldsymbol{E^\top_{ij}}\boldsymbol{\gamma_{1}}+\boldsymbol{G^\top_{ij}}\boldsymbol{\gamma_{2}}+(\boldsymbol{G_{ij}}\bigotimes \boldsymbol{E_{ij}})^\top\boldsymbol{\gamma_{3}}+\boldsymbol{Z^\top_{ij}}\boldsymbol{\alpha_{i}}+\epsilon_{ij}.}

Here \eqn{\boldsymbol{\gamma_{0}}} is the coefficient vector for \eqn{\boldsymbol{X_{ij}}}, \eqn{\boldsymbol{\gamma_{1}}} is the coefficient vector for \eqn{\boldsymbol{E_{ij}}}, \eqn{\boldsymbol{\gamma_{2}}} is the coefficient vector for the genetic variants, and \eqn{\boldsymbol{\gamma_{3}}} is the coefficient vector for the interactions of the genetic variants with environment factors.

where \eqn{\boldsymbol{\gamma_{1}}=(\gamma_{11},\dots,\gamma_{1p})^\top}, \eqn{\boldsymbol{\gamma_{2}}=(\gamma_{21},\dots,\gamma_{2m})^\top}, \eqn{\boldsymbol{\gamma_{3}}=(\boldsymbol{\gamma_{31}},\dots,\boldsymbol{\gamma_{3m}})^\top} where \eqn{\boldsymbol{\gamma_{3l}}=(\gamma_{3l1},\dots,\gamma_{3lp})^\top} for \eqn{l=1,\dots,m}.

The subject-specific random effects \eqn{\boldsymbol{\alpha_i}} capture within-subject correlation. For random intercept-and-slope model, \eqn{\boldsymbol{Z^\top_{ij}} = (1,j)} and  \eqn{\boldsymbol{\alpha_{i}} = (\alpha_{i1},\alpha_{i2})^\top}. For random intercept model, \eqn{Z_{ij} = 1} and \eqn{\alpha_{i} = \alpha_{i1}}.

When `structure=bilevel`(default), bi-level selection on main and interaction effects will be conducted corresponding to individual and group levels, respectively. When `structure="individual"`, selections only on individual levels by ignoring the group structure will be performed.

When `slope=TRUE` (default), random intercept-and-slope model will be used as the mixed effects model. Otherwise, random intercept model will be used.

When `sparse=TRUE` (default), spike-and-slab priors are imposed to identify important main and interaction effects. Otherwise, Laplacian shrinkage will be used.

When `robust=TRUE` (default), the distribution of \eqn{\epsilon_{ij}} is defined as an asymmetric Laplace distribution with density.

\eqn{
f(\epsilon_{ij}|\theta,\tau) = \theta(1-\theta)\exp\left\{-\tau\rho_{\theta}(\epsilon_{ij})\right\}
}, (\eqn{i=1,\dots,n,j=1,\dots,k }), which leads to a Bayesian formulation of quantile regression. Otherwise, \eqn{\epsilon_{ij}} follows a normal distribution.
\cr

Please check the references for more details about the prior distributions.
}
\examples{
data(data)

## default method (robust sparse bi-level selection under random intercept-and-slope model)
fit = mixedBayes(y,e,X,g,k,structure="bilevel")
fit$coefficient

## Compute TP and FP
b = selection(fit,sparse=TRUE)
index = which(coeff!=0)
pos = which(b != 0)
tp = length(intersect(index, pos))
fp = length(pos) - tp
list(tp=tp, fp=fp)
\donttest{
## alternative: robust sparse individual level selections under random intercept-and-slope model
fit = mixedBayes(y,e,X,g,k,structure="individual")
fit$coefficient

## alternative: non-robust sparse bi-level selection under random intercept-and-slope model
fit = mixedBayes(y,e,X,g,k,robust=FALSE, quant = NULL, structure="bilevel")
fit$coefficient

## alternative: robust sparse bi-level selection under random intercept model
fit = mixedBayes(y,e,X,g,k,slope=FALSE, structure="bilevel")
fit$coefficient

}

}
\seealso{
\code{\link{data}}
}
\keyword{models}
